type CashDrawerEventListener = (action:string,requestId:number)=>void
type PrinterStatusEventListener = (action:string)=>void
type PrintingEventListener = (action:string)=>void
enum PrintType{
    TEXT,
    IMAGE,
    BARCODE,
    QRCODE
}

class SuperApp{
    static {
        console.log('SuperApp is initialized.')
    }
    static initial(key:string){

    }
    static getInfo(){
        return {
            versionCode:1,
            versionName:"1.0.0a",
            buildServer:"dev",

        }
    }
    static Terminal = class{
        static getInfo(){
            return {
                terminalId:"1x121y",
                os:"Android",
                osVersion:"9",
                screenCount:1,
                screenSize:[{width:1024,height:768}]
            }
        }
    }
    static Store = class{
        static getInfo(){
            return {
                storeId:"12345",
                storeName:"storeName"
            }
        }
    }
    static User = class{
        static getInfo(){
            return {
                userId:"12345",
                userName:"userName"
            }
        }
    }
    static Device = class{

        static CashDrawer = class{
            static listener:CashDrawerEventListener
            static open(requestId:number):Boolean{
                console.log("Cash drawer is opened.")
                return true
            }
            static close(requestId:number):Boolean{
                console.log("Cash drawer is closed.")
                return true
            }
            static getStatus(){
                return "open|close|undefined"
            }
            static setCashDrawerEventListener(listener:CashDrawerEventListener){
                SuperApp.Device.CashDrawer.listener = listener
            }
        }

        static Printer = class{
            static statusListener:PrinterStatusEventListener
            static print(data:string,type:PrintType,printingListener:PrintingEventListener){

            }
            static setPrinterStatusListener(statusListener:PrinterStatusEventListener){
                SuperApp.Device.Printer.statusListener = statusListener
            }
        }
    }
    
}